

function Map(obj) {
	this._keys=[];
	this._values=[];
	if (typeof obj!="undefined") {
		// if an arg was passed, take its prop name/value pairs (if any) and add them as map entries:
		for (var key in obj) {
			this._keys.push(key);
			this._values.push(obj[key]);
		}
	}
}

Map[P].put=function(key, value) {
	if (this._keys.indexOf(key)>-1) {
		this._values[this._keys.indexOf(key)]=value;
	}
	else {
		this._keys.push(key);
		this._values.push(value);
	}
};

Map[P].get=function(key) {
	var idx=this._keys.indexOf(key);
	return (idx==-1?null:this._values[idx]);
};

Map[P].clear=function() {
	this._keys=[];
	this._values=[];
};

Map[P].isEmpty=function() {
	return (this._keys.length==0);
};

Map[P].containsKey=function(key) {
	return (this._keys.indexOf(key)!=-1);
};

Map[P].keysArray=function() {
	return this._keys;
};

Map[P].valuesArray=function() {
	return this._values;
};

Map[P].size=function() {
	return this._keys.length;
};

Map[P].remove=function(key) {
	var idx=this._keys.indexOf(key);
	if (idx>-1) {
		this._keys.splice(idx, 1);
		this._values.splice(idx, 1);
	}
};

Map[P].removeFirst=function() {
	if (this.size()>0) {
		this.remove(this._keys[0]);
	}
};

Map[P].toString=function() {
	var s="{";
	var ln=this._keys.length;
	for (var i=0; i<ln; i++) {
		if (i>0) {
			s+=", ";
		}
		s+=this._keys[i]+"="+this._values[i];
	}
	s+="}";
	return s;
};

